import { d as m, C as M, l as S, T as u } from "./common-Ba3Q-u_l.js";
let o;
try {
  o = m("API");
} catch (e) {
  console.error("SCORM 1.2 API not found!", e);
}
o || (console.error("SCORM 1.2 API not found!"), o = {
  LMSInitialize: function() {
    return !0;
  },
  LMSFinish: function() {
    return !0;
  },
  LMSGetValue: function(e) {
    return "";
  },
  LMSSetValue: function(e, s) {
    return s;
  },
  LMSCommit: function() {
    return !0;
  }
});
let a = !0, t = !1;
window.XPL_INTERFACE = {
  async initialize() {
    const s = await (await fetch("./config.json")).json();
    t = s.LoggingEnabled, o.LMSInitialize(""), t && console.log("LMSInitialize('')");
    const c = o.LMSGetValue("cmi.core.credit");
    t && console.log("LMSGetValue('cmi.core.credit') = " + c), c == "no-credit" && (a = !1);
    const r = await (await fetch("./data.json")).json();
    return {
      CourseData: new M(r),
      CourseConfiguration: s,
      EnableTracking: a,
      EnableLetterbox: !0
    };
  },
  finish() {
    a && (o.LMSSetValue("cmi.core.exit", "suspend"), o.LMSCommit(""), t && (console.log("LMSSetValue('cmi.core.exit', 'suspend')"), console.log("LMSCommit('')"))), o.LMSFinish(""), t && console.log("LMSFinish('')");
  },
  getAchievementProgress() {
    const e = o.LMSGetValue("cmi.objectives._count");
    t && console.log("LMSGetValue('cmi.objectives._count') = " + e);
    const s = parseInt(e) || 0;
    let c = [];
    for (let n = 0; n < s; n++) {
      const r = o.LMSGetValue("cmi.objectives." + n + ".id");
      t && console.log("LMSGetValue('cmi.objectives." + n + ".id') = " + r), c.push(parseInt(r));
    }
    return Promise.resolve(c);
  },
  setAchievementProgress(e) {
    if (a) {
      const s = o.LMSGetValue("cmi.objectives._count");
      t && console.log("LMSGetValue('cmi.objectives._count') = " + s);
      const c = parseInt(s) || 0;
      let n = [];
      for (let i = 0; i < c; i++) {
        const l = parseInt(o.LMSGetValue("cmi.objectives." + i + ".id"));
        t && console.log("LMSGetValue('cmi.objectives." + i + ".id') = " + l), e.indexOf(l) < 0 ? (o.LMSSetValue("cmi.objectives." + i + ".status", "incomplete"), t && console.log("LMSSetValue('cmi.objectives." + i + ".status', 'incomplete')")) : (o.LMSSetValue("cmi.objectives." + i + ".status", "completed"), t && console.log("LMSSetValue('cmi.objectives." + i + ".status', 'completed')")), n.push(l);
      }
      let r = 0;
      for (let i = 0; i < e.length; i++)
        if (n.indexOf(e[i]) < 0) {
          let l = c + r;
          r++, o.LMSSetValue("cmi.objectives." + l + ".id", e[i].toString()), o.LMSSetValue("cmi.objectives." + l + ".status", "completed"), t && (console.log("LMSSetValue('cmi.objectives." + l + ".id', " + e[i] + ")"), console.log("LMSSetValue('cmi.objectives." + l + ".status', 'completed')"));
        }
      o.LMSCommit(""), t && console.log("LMSCommit('')");
    }
  },
  getVariableState() {
    let e = {};
    const s = o.LMSGetValue("cmi.suspend_data");
    if (s)
      try {
        e = JSON.parse(S.decompressFromBase64(s)) || {};
      } catch (c) {
        console.error("Error decompressing variable state! Make sure your LMS is correctly URL-encoding strings before sending them to your server.", c), e = {};
      }
    return t && console.log("LMSGetValue('cmi.suspend_data') = " + JSON.stringify(e)), Promise.resolve(e);
  },
  setVariableState(e) {
    a && (o.LMSSetValue("cmi.suspend_data", S.compressToBase64(JSON.stringify(e))), o.LMSCommit(""), t && (console.log("LMSSetValue('cmi.suspend_data', '" + JSON.stringify(e) + "')"), console.log("LMSCommit('')")));
  },
  getModuleHistory() {
    const e = o.LMSGetValue("cmi.core.lesson_location");
    let s;
    return e && (s = JSON.parse(e)), t && console.log("LMSGetValue('cmi.core.lesson_location') = " + (s ? JSON.stringify(s) : "")), Promise.resolve(s);
  },
  setModuleHistory(e) {
    a && (o.LMSSetValue("cmi.core.lesson_location", e ? JSON.stringify(e) : ""), o.LMSCommit(""), t && (console.log("LMSSetValue('cmi.core.lesson_location', '" + (e ? JSON.stringify(e) : "") + "')"), console.log("LMSCommit('')")));
  },
  getScore() {
    const e = {
      Min: parseFloat(o.LMSGetValue("cmi.core.score.min")),
      Max: parseFloat(o.LMSGetValue("cmi.core.score.max")),
      Raw: parseFloat(o.LMSGetValue("cmi.core.score.raw"))
    };
    return t && (console.log("LMSGetValue('cmi.core.score.min') = " + e.Min), console.log("LMSGetValue('cmi.core.score.max') = " + e.Max), console.log("LMSGetValue('cmi.core.score.raw') = " + e.Raw)), isNaN(e.Min) && (e.Min = 0), isNaN(e.Max) && (e.Max = 0), isNaN(e.Raw) && (e.Raw = 0), Promise.resolve(e);
  },
  setScore(e) {
    a && (o.LMSSetValue("cmi.core.score.min", e.Min.toString()), o.LMSSetValue("cmi.core.score.max", e.Max.toString()), o.LMSSetValue("cmi.core.score.raw", e.Raw.toString()), o.LMSCommit(""), t && (console.log("LMSSetValue('cmi.core.score.min', " + e.Min + ")"), console.log("LMSSetValue('cmi.core.score.max', " + e.Max + ")"), console.log("LMSSetValue('cmi.core.score.raw', " + e.Raw + ")"), console.log("LMSCommit('')")));
  },
  getStatus() {
    const e = o.LMSGetValue("cmi.core.lesson_status");
    t && console.log("LMSGetValue('cmi.core.lesson_status') = " + e);
    let s = u.notStarted;
    return e === "incomplete" ? s = u.startedNotCompleted : e === "completed" && (s = u.finished), Promise.resolve(s);
  },
  setStatus(e) {
    if (a)
      switch (e) {
        case u.notStarted:
          o.LMSSetValue("cmi.core.lesson_status", "not attempted"), t && console.log("LMSSetValue('cmi.core.lesson_status', 'not attempted')");
          break;
        case u.startedNotCompleted:
          o.LMSSetValue("cmi.core.lesson_status", "incomplete"), t && console.log("LMSSetValue('cmi.core.lesson_status', 'incomplete')");
          break;
        case u.completedNotFinished:
        case u.finished:
          o.LMSSetValue("cmi.core.lesson_status", "completed"), t && console.log("LMSSetValue('cmi.core.lesson_status', 'completed')");
          break;
      }
  }
};
